// ignore_for_file: unused_element, unused_import
// ignore_for_file: always_put_required_named_parameters_first
// ignore_for_file: constant_identifier_names
// ignore_for_file: lines_longer_than_80_chars

part of cresce.api;

class ProvidedSeriesModel {
  /// Returns a new [ProvidedSeriesModel] instance.
  ProvidedSeriesModel({
    required this.from,
    required this.to,
    required this.recurrenceId,
  });

  DateTime from;

  DateTime to;

  int recurrenceId;

  @override
  bool operator ==(Object other) =>
      identical(this, other) ||
      other is ProvidedSeriesModel &&
          other.from == from &&
          other.to == to &&
          other.recurrenceId == recurrenceId;

  @override
  int get hashCode =>
      // ignore: unnecessary_parenthesis
      (from.hashCode) + (to.hashCode) + (recurrenceId.hashCode);

  @override
  String toString() =>
      'ProvidedSeriesModel[from=$from, to=$to, recurrenceId=$recurrenceId]';

  Map<String, dynamic> toJson() {
    final json = <String, dynamic>{};
    json[r'from'] = from.toUtc().toIso8601String();
    json[r'to'] = to.toUtc().toIso8601String();
    json[r'recurrenceId'] = recurrenceId;
    return json;
  }

  /// Returns a new [ProvidedSeriesModel] instance and imports its values from
  /// [value] if it's a [Map], null otherwise.
  // ignore: prefer_constructors_over_static_methods
  static ProvidedSeriesModel fromJson(dynamic value) {
    final json = value.cast<String, dynamic>();
    return ProvidedSeriesModel(
      from: mapDateTime(json, r'from', '')!,
      to: mapDateTime(json, r'to', '')!,
      recurrenceId: mapValueOfType<int>(json, r'recurrenceId')!,
    );
  }

  static List<ProvidedSeriesModel> listFromJson(dynamic json) =>
      json.map(ProvidedSeriesModel.fromJson).toList();

  static Map<String, ProvidedSeriesModel> mapFromJson(dynamic json) {
    final map = <String, ProvidedSeriesModel>{};
    if (json is Map && json.isNotEmpty) {
      json.cast<String, dynamic>().forEach((key, dynamic value) =>
          map[key] = ProvidedSeriesModel.fromJson(value));
    }
    return map;
  }

  // maps a json object with a list of ProvidedSeriesModel-objects as value to a dart map
  static Map<String, List<ProvidedSeriesModel>> mapListFromJson(dynamic json) {
    final map = <String, List<ProvidedSeriesModel>>{};
    if (json is Map && json.isNotEmpty) {
      json.cast<String, dynamic>().forEach((key, dynamic value) {
        map[key] = ProvidedSeriesModel.listFromJson(value);
      });
    }
    return map;
  }
}
